LootSink = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0", "Sink-1.0")
local core = LootSink

function core:OnInitialize()
	self:RegisterDB("LootSinkDB")
	self:RegisterDefaults("profile", {
		bags = true,
	})

	local function getter(k) return self.db.profile[k] end
	local function setter(k, t) self.db.profile[k] = t end
	local options = {
		type = "group",
		args = {
			bags = {
				type = "toggle",
				name = "Bags",
				desc = "Show how many you are already carrying",
				get =  function() return self.db.profile.bags end,
				set =  function(t) self.db.profile.bags = t end,
			},
		},
	}
	options.args.output = AceLibrary("Sink-1.0"):GetAceOptionsDataTable(self).output
	self:RegisterChatCommand({"/ls", "/lootsink"}, options)
end

function core:OnEnable(first)
	self:RegisterEvent("CHAT_MSG_LOOT")
end

local loot_pattern = (LOOT_ITEM_SELF):gsub("%%s", "(.+)") -- "You receive loot: %s."
local loot_multiple_pattern = (LOOT_ITEM_SELF_MULTIPLE):gsub("%%sx%%d", "(.+)x(%%d+)") -- "You receive loot: %sx%d."
function core:CHAT_MSG_LOOT()
	--arg1 will be the loot message
	local link, quantity = arg1:match(loot_multiple_pattern)
	if not link then
		link = arg1:match(loot_pattern)
		if not link then
			return
		end
	end
	local name, _, rarity = GetItemInfo(link)
	if name then
		self:Pour("["..name.."]"..
			(quantity and ("x"..quantity) or "")..
			(self.db.profile.bags and (" ("..(GetItemCount(link) + (quantity or 1))..")") or ""),
			GetItemQualityColor(rarity)
		)
	end
end
